<template>
    <div class="register section">
        <base-container>
            <base-form
                scope="register-form-scope"
                header="Регистрация"
                class="register-form"
                autocomplete="off"
                @sendForm="userRegister"
            >
                <!-- EMAIL start -->
                <div class="form-block__wrapper-input">
                    <div
                        class="form-block__wrapper-autocomplete"
                        style="position: relative"
                    >
                        <input
                            ref="EMAIL"
                            :class="['input default', {'is-danger': (errors.has('register-form-scope.EMAIL')) }]"
                            :placeholder="$t('form.inputs.holder.emailPhone')"
                            type="text"
                            name="EMAIL"
                            required
                            autofocus
                            v-model="email"
                            v-mask="mask"
                            v-validate="'phoneOrEmail'"
                            @keypress="changeMask"
                            @focus="setFocusElement"
                            @blur="clearFocusElement"
                        >
                        <base-autocomplete
                            v-show="typeRegistration === 'email' && focusElement === 'EMAIL'"
                            :url=getUrlSuggestEmail
                            :value="email"
                            @selected="selectedItemAutocomplete"
                        />
                    </div>
                    <transition name="slide">
                        <div
                            v-show="errors.has('register-form-scope.EMAIL') &&
                            email !== '' &&
                            focusElement !== 'EMAIL'"
                        >
                            <div class="form-block__error-message error-message">
                                {{ errors.first('EMAIL', 'register-form-scope') }}
                            </div>
                        </div>
                    </transition>
                </div>
                <div v-if="getErrorsEmailOrPhone" class="error-message-list">
                    <div
                        v-for="(error, key) in getErrorsEmailOrPhone"
                        :key="key" class="form-block__error-message error-message"
                    >
                        {{ error }}
                    </div>
                </div>
                <!-- EMAIL end -->
                <!-- PASSWORD start -->
                <div class="form-block__wrapper-input form-block__wrapper-input--relative">
                    <input
                        ref="PASSWORD"
                        :class="[
                            'input default',
                            {
                                'is-danger': (errors.has('register-form-scope.PASSWORD'))
                            }
                        ]"
                        :placeholder="$t('form.inputs.holder.password')"
                        :type="visiblePassword ? 'text' : 'password'"
                        name="PASSWORD"
                        required
                        v-model.lazy="password"
                        v-validate="'password'"
                        @focus="setFocusElement"
                        @blur="clearFocusElement"
                    >
                    <div :class="['form-block__eye', getClassForEyes, 'pointer']"
                         @click="changeVisiblePassword"
                    ></div>
                    <transition name="slide">
                        <div
                            v-show="errors.has('register-form-scope.PASSWORD') &&
                            password !== '' &&
                            focusElement !== 'PASSWORD'"
                        >
                            <div class="form-block__error-message error-message">
                                {{ errors.first('PASSWORD', 'register-form-scope') }}
                            </div>
                        </div>
                    </transition>
                </div>
                <!-- PASSWORD end -->
                <!-- CONFIRM PASSWORD start -->
                <div class="form-block__wrapper-input form-block__wrapper-input--relative">
                    <input
                        ref="REPASSWORD"
                        :class="[
                            'input default',
                            {
                                'is-danger': (errors.has('register-form-scope.REPASSWORD'))
                            }
                        ]"
                        :placeholder="$t('form.inputs.holder.repassword')"
                        :type="visiblePassword ? 'text' : 'password'"
                        name="REPASSWORD"
                        v-model.lazy="repassword"
                        v-validate="'repassword:PASSWORD'"
                        @focus="setFocusElement"
                        @blur="clearFocusElement"
                    >
                    <transition name="slide">
                        <div
                            v-show="errors.has('register-form-scope.REPASSWORD') &&
                            repassword !== '' &&
                            focusElement !== 'REPASSWORD'"
                        >
                            <div class="form-block__error-message error-message">
                                {{ errors.first('REPASSWORD', 'register-form-scope') }}
                            </div>
                        </div>
                    </transition>
                </div>
                <p class="form-block__description">
                    {{ $t('form.6-digit_code') }}
                </p>
                <!-- CONFIRM PASSWORD end -->
                <!-- TERMS_IPEX start -->
                <base-checkbox name="user-of-condition-ipex">
                    {{ $t('form.i_agree.i_accept') }}
                    <a @click.prevent="showAgreement('ipex')">
                        {{ $t('form.i_agree.user_agreement') }}
                    </a>
                    {{ $t('form.i_agree.with_IPEX') }}
                </base-checkbox>
                <!-- TERMS_IPEX end -->
                <!-- TERMS_IPCHAIN start -->
                <base-checkbox name="user-of-condition-ip-chain">
                    {{ $t('form.i_agree.i_accept') }}
                    <a @click.prevent="showAgreement('ipchain')">
                        {{ $t('form.i_agree.user_agreement') }}
                    </a>
                    {{ $t('form.i_agree.with_IPCHAIN') }}
                </base-checkbox>
                <!-- TERMS_IPCHAIN end -->
                <!-- SUBMIT start -->
                <base-button :text="$t('button.registration')" />
                <!-- SUBMIT end -->
                <div class="form-block__authentication">
                    {{ $t('form.has_account') }}
                    <a @click="$router.push('/login')">{{ $t('header.entrance') }}</a>
                </div>
            </base-form>
        </base-container>
    </div>
</template>

<script>
import { REGEXP_PHONE } from 'const/regexp';
import { MASK_PHONE } from 'const/mask';
import { API_REGISTER, API_SUGGEST_EMAIL } from 'const/api';

export default {
    name: 'registration-form',
    data() {
        return {
            email: '',
            password: '',
            repassword: '',
            visiblePassword: false,
            mask: '',
            focusElement: null,
            autocomplete: false
        };
    },
    computed: {
        getErrorsEmailOrPhone() {
            if (this.apiErrors.email) {
                return this.apiErrors.email;
            } else if (this.apiErrors.phone) {
                return this.apiErrors.phone;
            }
            return null;
        },
        cleanEmail() {
            return Array.from(this.email).reduce((acc, val, index) => {
                if (val !== MASK_PHONE.ru[index] && this.email) acc += val;
                return acc;
            }, '');
        },
        getClassForEyes() {
            return this.visiblePassword ? 'form-block__eye--open' : 'form-block__eye--close';
        },
        typeRegistration() {
            if (!this.email) return null;
            return REGEXP_PHONE.test(this.cleanEmail) ? 'phone' : 'email';
        },
        getUrlSuggestEmail() {
            return API_SUGGEST_EMAIL;
        },
        ...mapState('api', ['apiErrors']),
        ...mapState('account', ['token'])
    },
    methods: {
        selectedItemAutocomplete(value) {
            this.email = value;
        },
        clearFocusElement() {
            this.focusElement = null;
        },
        setFocusElement(e) {
            this.focusElement = e.target.name;
        },
        changeMask(e) {
            const letter = String.fromCharCode(e.keyCode);
            if (
                (REGEXP_PHONE.test(letter) && this.mask !== MASK_PHONE.ru) &&
                (!this.email || REGEXP_PHONE.test(this.email))
            ) {
                this.mask = MASK_PHONE.ru;
            } else if (/[A-Za-z]/.test(letter)) {
                this.mask = '';
                this.email = this.cleanEmail;
            }
        },
        changeVisiblePassword() {
            this.visiblePassword = !this.visiblePassword;
        },
        userRegister(event) {
            const scope = event.target.dataset['vvScope'];
            this.$validator.validateAll(scope).then(result => {
                const params = {
                    service: 'ipex',
                    password: this.password,
                    password_confirmation: this.repassword,
                    license: 1,
                    personal: 1
                };

                if (result) {
                    REGEXP_PHONE.test(this.email)
                        ? this.registrationByNumber(params)
                        : this.registrationByEmail(params);
                }
            });
        },
        registrationByNumber(params) {
            const data = Object.assign({
                phone: `7${this.cleanEmail}`
            }, params);

            this.$emit('setDataComponent', { phone: this.email });
            this.sendRegistrationData(data);
        },
        registrationByEmail(params) {
            const data = Object.assign({
                email: this.email
            }, params);

            this.sendRegistrationData(data);
        },
        sendRegistrationData(data) {
            this.changeStatusForm();
            this.clearApiErrors();

            this.$http.post(API_REGISTER, data)
                .then(response => {
                    this.typeRegistration === 'phone'
                        ? this.setRegistrationPageComponent('registration-confirm-phone')
                        : this.setRegistrationPageComponent('registration-confirm-email');
                })
                .catch(error => {
                    console.error('error', error);
                    const { errors } = error.response.data;
                    this.addApiError(errors);
                })
                .finally(() => {
                    this.changeStatusForm();
                });
        },
        showAgreement(agreement) {
            this.setRegistrationAgreement(agreement);
            this.setRegistrationPageComponent('registration-agreement');
        },
        ...mapActions('registration', ['setRegistrationPageComponent', 'setRegistrationAgreement']),
        ...mapActions('api', ['clearApiErrors', 'addApiError']),
        ...mapActions('stateForm', ['changeStatusForm'])
    }
};
</script>

<style lang="sass">
    @import '~assets/styles/animations/slide';
</style>
